//
//  test_callbacks.cpp
//  Demo_Mac
//
//  Created by cppwang(王缘) on 2019/5/17.
//  Copyright © 2019 Tencent. All rights reserved.
//

#include "test_callbacks.h"
#include <thread>

extern int waitForLoginComplete;

/* xiaowei callbck */

bool TESTCALLBACK::onRequestCallback(const char *voice_id, XIAOWEI_EVENT event, const char *state_info, const char *extend_info, unsigned int extend_info_len)
{
    printf("onRequestCallback:: voiceID = %s ,event = %d \n", voice_id,event);
    
    if(event == xiaowei_event_on_idle)
    {
        printf("onRequestCallback:: dialog end \n");
    }
    if(event == xiaowei_event_on_request_start)
    {
        printf("onRequestCallback:: request start \n");
    }
    if(event == xiaowei_event_on_speak)
    {
        printf("onRequestCallback:: on speak \n");
    }
    if(event == xiaowei_event_on_silent)
    {
        printf("onRequestCallback:: on silent \n");
    }
    if(event == xiaowei_event_on_recognize)
    {
        //process asr result
        std::string asrResult = extend_info;
        printf("onRequestCallback:: get asr result: %s \n",extend_info);
    }
    if(event == xiaowei_event_on_response)
    {
        //get final result
        XIAOWEI_PARAM_RESPONSE *response = (XIAOWEI_PARAM_RESPONSE *)state_info;
        printf("***************************************** Debug resposne ***********************************\n");
        printf("********basic result: errcode = %d, request_text = %s, response_text = %s, groupSize = %d responsedata = %s ******\n",
               response->error_code,response->request_text,response->response_text, response->resource_groups_size, response->response_data);
        for(int i=0;i<response->resource_groups_size;i++)
        {
            for (int j=0; j<response->resource_groups[i].resources_size; j++)
            {
                printf("###In group %d, resource %d, id = %s, type = %d , content = %s, playcount = %d, extendBuf = %s \n"
                       ,i,j,response->resource_groups[i].resources[j].id,response->resource_groups[i].resources[j].format,response->resource_groups[i].resources[j].content,response->resource_groups[i].resources[j].play_count,response->resource_groups[i].resources[j].extend_buffer);
            }
        }
        
        printf("action type: %d \n",response->play_behavior);
        if(response)
        {
            //you need to process the result here async
            if(response->context.id != NULL && strlen(response->context.id) >= 16 )
                printf("onRequestCallback:: session not end, should start another voice request with this session id = %s \n",response->context.id);
        }
    }
    if(event == xiaowei_event_on_tts)
    {
        //get final result
        XIAOWEI_PARAM_AUDIO_DATA *ttsData = (XIAOWEI_PARAM_AUDIO_DATA *)state_info;
        printf("onRequestCallback:: get tts package \n");
        if(ttsData && ttsData->id)
        {
            printf("ttsData id = %s, seq = %d, is end = %d",ttsData->id,ttsData->seq,ttsData->is_end);
        }
    }
    if(event == xiaowei_event_on_response_intermediate)
    {
        printf("onRequestCallback:: this is not for use \n");
    }
    
    return true;
}

bool TESTCALLBACK::onNetDelayCallback(const char *voice_id, unsigned long long time)
{
    printf("NetDelayCallback,not use\n");
    return true;
}

void TESTCALLBACK::xwCommonCallback(const char* voice_id, int xiaowei_err_code, const char * json)
{
    printf("xwCommonCallback, voice_id = %s, errcode = %d, json = %s\n", voice_id,xiaowei_err_code,json);
}

void TESTCALLBACK::loginComplete(int error_code)
{
    printf("login ok , err code = %d\n",error_code);
    if(! error_code){
        waitForLoginComplete = 1;
    }
    
}

void TESTCALLBACK::onBinderListChange(int error_code, DEVICE_BINDER_INFO *pBinderList, int nCount)
{
    printf("onBinderListChange count = %d\n",nCount);
    for(int i=0; i<nCount ;i++)
    {
        printf("binder[%d], username = %s, nickname = %s, remark = %s, exportid = %s\n",
               i,pBinderList[i].username, pBinderList[i].nickname,pBinderList[i].remark,pBinderList[i].export_id);
    }
}

void TESTCALLBACK::userLog(int level, const char *tag, const char *filename, int line, const char *funcname, const char *data, uint32_t len)
{
    printf("***log callback***\n");
    printf("level = %d, tag = %s, filename = %s, line = %d, funcname = %s, data = %s, len = %d\n",level,tag,filename,line,funcname,data,len);
}


///VOIP

void TESTCALLBACK::onVoipInvite(const char *fromUsername, unsigned long long roomId, const char *appId)
{
     printf("onVoipInvite,fromusername = %s, roomid = %llu, appip = %s\n",fromUsername,roomId,appId);
}
void TESTCALLBACK::onReceiveMessage(const char *fromUsername, const char *fromNickname, const char *fromHeadImageUrl, const char *content, int mediaType)
{
    printf("onReceiveMessage,fromusername = %s, fromNickname = %s, mediaType = %d\n",fromUsername,fromHeadImageUrl,mediaType);
}
void TESTCALLBACK::onSendMsgResult(int errCode)
{
    printf("onSendMsgResult,errcode = %d\n",errCode);
}

//contact

void TESTCALLBACK::autoAcceptContactRequest(DEVICE_BINDER_INFO info)
{
    printf("autoAcceptContactRequest info.username = %s",info.username);
    device_handle_binder_verify_request(info.username, true);
}

//qr

void TESTCALLBACK::onQrCode(int errCode, const char *url, unsigned int expireTime)
{
    printf("on get qr code, errcode = %d, url = %s, expireTime = %d\n",errCode,url,expireTime);
}
void TESTCALLBACK::onPublicCode(int errCode, const char *path, unsigned int expireTime)
{
    printf("on get onPublicCode, errcode = %d, path = %s, expireTime = %d\n",errCode,path,expireTime);
}


void TESTCALLBACK::onTicket(int errCode, const char *ticket, unsigned int expireTime)
{
    if (errCode) {
        printf("onTicket error, errcode = %d",errCode);
        return;
    }
    printf("onTicket, errcode = %d, ticket = %s, expireTime = %d,",errCode, ticket,expireTime);
}
