//
//  test_callbacks.h
//  Demo_Mac
//
//  Created by cppwang(王缘) on 2019/5/19.
//  Copyright © 2019 Tencent. All rights reserved.
//

#ifndef test_callbacks_h
#define test_callbacks_h

#include "test_functions.h"

class TESTCALLBACK {
public:
    static bool onRequestCallback(const char *voice_id, XIAOWEI_EVENT event, const char *state_info, const char *extend_info, unsigned int extend_info_len);
    static bool onNetDelayCallback(const char *voice_id, unsigned long long time);
    static void xwCommonCallback(const char* voice_id, int xiaowei_err_code, const char * json);
    
    
    static void loginComplete(int error_code);
    static void onBinderListChange(int error_code, DEVICE_BINDER_INFO *pBinderList, int nCount);
    
    static void userLog(int level, const char *tag, const char *filename, int line, const char *funcname, const char *data, uint32_t len);
    
    //qrcode
    static void onQrCode(int errCode, const char *url, unsigned int expireTime);
    static void onPublicCode(int errCode, const char *path, unsigned int expireTime);
    static void onTicket(int errCode, const char *ticket, unsigned int expireTime);
    
    //voip
    static void onVoipInvite(const char *fromUsername, unsigned long long roomId, const char *appId);
    static void onReceiveMessage(const char *fromUsername, const char *fromNickname, const char *fromHeadImageUrl, const char *content, int mediaType);
    static void onSendMsgResult(int errCode);
    
    //contact
    static void autoAcceptContactRequest(DEVICE_BINDER_INFO info);
};

#endif /* test_callbacks_h */

