//
//  test_functions.cpp
//
//  Created by cppwang(王缘) on 2019/5/19.
//  Copyright © 2019 Tencent. All rights reserved.
//

#include "test_functions.h"
#include "test_callbacks.h"

void TESTFUN::login()
{
    /* test param */
    DEVICE_INFO device_info = {0};
    DEVICE_INIT_PATH path = {0};
    DEVICE_NOTIFY notify = {0};
    
    /* device_info you need to change those */
    device_info.device_license = (char*){your licence};
    device_info.device_serial_number = (char*){your sn};
    device_info.xiaowei_appid = (char*){your appid};
    device_info.product_id = {your pid};
    device_info.key_version = {your key_version};
    /* device_info end*/
    
    device_info.run_mode = 0;
    //notify
    notify.on_login_complete = TESTCALLBACK::loginComplete;
    notify.on_binder_list_change = TESTCALLBACK::onBinderListChange;
    //contact test
    notify.on_binder_verify = TESTCALLBACK::autoAcceptContactRequest;
    notify.on_qr_code_refresh = TESTCALLBACK::onPublicCode;
    //path
    char cwd[512];
    if (getcwd(cwd, sizeof(cwd)) != NULL) {
        printf("cwd: %s\n", cwd);
    } else {
        printf("can't get cwd!\n");
        return;
    }
    struct stat st = {0};
    std::string work_path(cwd);
    if (stat(work_path.c_str(), &st) == -1) {
        mkdir(work_path.c_str(), 0700);
    }
    path.system_path = (char *)work_path.c_str();
    path.system_path_capacity = 1024*1024;
    /* test param end */
    printf("init device result = %d \n", device_init(&device_info, &notify, &path, 0,NULL));
}

void TESTFUN::loginWithAllService()
{
    /* test param */
    DEVICE_INFO device_info = {0};
    DEVICE_INIT_PATH path = {0};
    DEVICE_NOTIFY notify = {0};
    SERVICE_CALLBACK callback = {0};
    
    /* device_info you need to change those
     
    device_info.device_license = (char*){your licence};
    device_info.device_serial_number = (char*){your sn};
    device_info.xiaowei_appid = (char*){your pid};
    device_info.product_id = {your pid};
    device_info.key_version = {your key_version};
     
    device_info end*/
    
    //notify
    notify.on_login_complete = TESTCALLBACK::loginComplete;
    notify.on_binder_list_change = TESTCALLBACK::onBinderListChange;
    //contact test
    notify.on_binder_verify = TESTCALLBACK::autoAcceptContactRequest;
    notify.on_qr_code_refresh = TESTCALLBACK::onPublicCode;
    
    //callback
    callback.voip_callback.on_receiveMessage = TESTCALLBACK::onReceiveMessage;
    callback.voip_callback.on_send_msg_result = TESTCALLBACK::onSendMsgResult;
    callback.voip_callback.on_voip_invite = TESTCALLBACK::onVoipInvite;
    callback.xiaowei_callback.on_net_delay_callback = TESTCALLBACK::onNetDelayCallback;
    callback.xiaowei_callback.on_request_callback = TESTCALLBACK::onRequestCallback;
    //path
    char cwd[512];
    if (getcwd(cwd, sizeof(cwd)) != NULL) {
        printf("cwd: %s\n", cwd);
    } else {
        printf("can't get cwd!\n");
        return;
    }
    std::string work_path(cwd);
    work_path.append("/device");
    struct stat st = {0};
    if (stat(work_path.c_str(), &st) == -1) {
        mkdir(work_path.c_str(), 0700);
    }
    path.system_path = (char *)work_path.c_str();
    path.system_path_capacity = 1024*1024;
    /* test param end */
    int result = device_init(&device_info, &notify, &path, auto_start_xiaowei | auto_start_voip, &callback);
    printf("init device result = %d \n", result);
}

void TESTFUN::getDeviceSDKVer()
{
    /* get sdk version */
    unsigned int main_ver;
    unsigned int sub_ver;
    unsigned int fix_ver;
    unsigned int build_no;
    device_get_sdk_version(&main_ver, &sub_ver, &fix_ver, &build_no);
    printf("\ndevice sdk ver = %d.%d.%d.%d\n",main_ver,sub_ver,fix_ver,build_no);
}

void TESTFUN::getQRCode()
{
    char buff[300];
    printf("get qrcode result = %d\n",device_get_qr_code(buff, 300));
    printf("qrcode = %s\n",buff);
}

void TESTFUN::getBinder()
{
    DEVICE_BINDER_INFO binders[20] = {0};
    int count = 20;
    device_get_binder_list(binders, &count);
    printf("get binder count = %d\n",count);
    for(int i=0; i<count ;i++)
    {
        printf("binder[%d], username = %s, nickname = %s, remark = %s, exportid = %s\n",
               i,binders[i].username, binders[i].nickname,binders[i].remark,binders[i].export_id);
    }
}

void TESTFUN::getUnverify()
{
    DEVICE_BINDER_INFO binders[5] = {0};
    int count = 5;
    device_get_all_unverify_bind_request(binders, &count);
    printf("get unverify count = %d\n",count);
    for(int i=0; i<count ;i++)
    {
        printf("unverify[%d], username = %s, nickname = %s, remark = %s, exportid = %s\n",
               i,binders[i].username, binders[i].nickname,binders[i].remark,binders[i].export_id);
    }
}

void TESTFUN::setLogFunc()
{
    device_set_log_func(TESTCALLBACK::userLog, 0, false);
}

void TESTFUN::getDynamicQrCode()
{
    device_refresh_dynamic_qr_code();
}

void TESTFUN::getPublicQrCode()
{
//    device_get_public_qr_code(TESTCALLBACK::onPublicCode);
}
void TESTFUN::getTicket()
{
    device_get_bind_ticket(TESTCALLBACK::onTicket);
}


////////////////////
void TESTFUN::xiaoweiStart()
{
    /* xiaowei service */
    XIAOWEI_CALLBACK xiaoweiCB = {0};
    xiaoweiCB.on_request_callback = TESTCALLBACK::onRequestCallback;
    xiaoweiCB.on_net_delay_callback = TESTCALLBACK::onNetDelayCallback;
    XIAOWEI_NOTIFY xiaoweoNotify = {0};
    printf("init xiaowei service result = %d \n",xiaowei_service_start(&xiaoweiCB, &xiaoweoNotify));
}

void TESTFUN::xiaoweiReportPlayState()
{
    XIAOWEI_PARAM_STATE st = {0};
    st.play_id = NULL;
    st.play_offset = 12344;
    st.play_content = "test_content";
    st.skill_info.id = "8dab4796-fa37-4114-0024-7637fa2b0005";
    st.skill_info.name = "FM-故事";
    st.play_state = XIAOWEI_PLAY_STATE::play_state_idle;
    st.availability = (XIAOWEI_AVAILABILITY)0;
    st.resource_type = XIAOWEI_RESOURCE_FORMAT::xiaowei_resource_remind;
    st.resource_name = "稻香";
    st.performer = "周杰伦";
    st.collection = "unknow";
    st.cover_url = "http://adadada";
    st.brightness = 50;
    st.volume = 60;
    xiaowei_report_state(&st);
}

void TESTFUN::xiaoweiGetMorePlayList()
{
    char vid[33] = {0};
    std::string str = "{\"skill_info\": {\"id\": \"8dab4796-fa37-4114-0024-7637fa2b0001\",\"name\": \"FM\"},\"play_id\": \"rd001zmy3Y3Evni9\",\"is_up\": false}";
    xiaowei_request_cmd(vid, "PLAY_RESOURCE", "get_more", str.c_str(),TESTCALLBACK::xwCommonCallback);
    
//    xiaowei_resource_get_list(voiceID, DEF_XIAOWEI_SKILL_ID_MUSIC, "unique_id=101555425&p=0&uuid=0", 5, false);
}

void TESTFUN::xiaoweiGetQQMusicVip()
{
    char vid[33] = {0};
    std::string str = "";
    xiaowei_request_cmd(vid, "QQMUSIC", "get_vip_info", str.c_str(),TESTCALLBACK::xwCommonCallback);
}
void TESTFUN::xiaoweiGetFavoriteList()
{
    char vid[33] = {0};
    std::string str = "{\"skill_info\":{\"id\":\"8dab4796-fa37-4114-0011-7637fa2b0001\",\"name\":\"音乐\"}}";
    xiaowei_request_cmd(vid, "PLAY_RESOURCE", "get_favorite_list", str.c_str(),TESTCALLBACK::xwCommonCallback);
}
void TESTFUN::xiaoweiSetFavorite(bool isFavorite)
{
    char vid[33] = {0};
    XIAOWEI_PARAM_SKILL skill_info;
    skill_info.id = DEF_XIAOWEI_SKILL_ID_MUSIC;
    skill_info.name = "音乐";
    xiaowei_resource_set_favorite(vid, &skill_info, "unique_id=214713358&type=cur", isFavorite);
}
void TESTFUN::xiaoweiSetMusicQuality(int quality)
{
    xiaowei_resource_set_quality(quality);
    
}

void TESTFUN::xiaoweiGetMusicQuality()
{
    char vid[33] = {0};
    std::string str = "{\"skill_info\":{\"id\":\"8dab4796-fa37-4114-0011-7637fa2b0001\",\"name\":\"音乐\"},\"quality_config\":{\"type\":1}}";
    xiaowei_request_cmd(vid, "PLAY_RESOURCE", "quality_config", str.c_str(),TESTCALLBACK::xwCommonCallback);
}

void TESTFUN::xiaoweiGetRecentHistory()
{
    char vid[33] = {0};
    std::string str = "{\"skill_info\": {\"id\": \"8dab4796-fa37-4114-0011-7637fa2b0001\",\"name\": \"音乐\"},\"play_id\": \"rd001zmy3Y3Evni9\",\"is_up\": false}";
    xiaowei_request_cmd(vid, "PLAY_RESOURCE", "get_history", str.c_str(),TESTCALLBACK::xwCommonCallback);
}

void TESTFUN::xiaoweiTextReq()
{
    const char *text = "我要听歌";
    char voice_id[33] = {0};
    XIAOWEI_PARAM_CONTEXT context = {0};
    context.silent_timeout = 500;
    context.speak_timeout = 5000;
    context.voice_request_begin = true;
    context.voice_request_end = false;
    printf("send text request, result = %d\n",xiaowei_request(voice_id, xiaowei_chat_via_text, text, (int)strlen(text), &context));
}

void TESTFUN::xiaoweiTextReq(std::string text)
{
    char voice_id[33] = {0};
    XIAOWEI_PARAM_CONTEXT context = {0};
    context.silent_timeout = 500;
    context.speak_timeout = 5000;
    context.voice_request_begin = true;
    context.voice_request_end = false;
    printf("send text request, result = %d\n",xiaowei_request(voice_id, xiaowei_chat_via_text, text.c_str(), (int)(text.length()), &context));
}

void TESTFUN::xiaoweiVoicReq()
{
    char buf[4800];
    FILE* f = fopen("./resource/music.wav", "rb+");
    fseek(f, 46, 0);
//    FILE* f = fopen("./resource/send_asr.pcm", "rb+");
    size_t read = 0;
    
    char voice_id[33] = {0};
    XIAOWEI_PARAM_CONTEXT context = {0};
    context.silent_timeout = 500;
    context.speak_timeout = 5000;
    context.voice_request_begin = true;
    context.voice_request_end = false;
    
    printf("voice request begin");
    
    XIAOWEI_PARAM_PROPERTY property = xiaowei_param_local_vad;//本地静音检测
    
    context.voice_request_begin = true;//第一个语音包begin要是true，在这之前也可以选择性调stop_request
    context.request_param = property;
    read = fread(buf, 1, 3200, f);
    
    xiaowei_request(voice_id, xiaowei_chat_via_voice, buf, (int)read, &context);
    context.voice_request_begin = false;

    int i = 0;
    while(1)//正常收到静音就无需再发送了，这里先不管
    {
        struct timeval tv;
        gettimeofday(&tv,NULL);
        long starttime = tv.tv_usec/1000 + tv.tv_sec*1000;
        read = fread(buf, 1, 1024, f);
        if(read == 0) break;
        printf("send voice request data[%d], result = %d\n",i,xiaowei_request(voice_id, xiaowei_chat_via_voice, buf, (int)read, &context));
        gettimeofday(&tv,NULL);
        long endtime = tv.tv_usec/1000 + tv.tv_sec*1000;
//        printf("testsend over:%d...end time = %ld",i,endtime);
//        printf("***testsend[%d]: starttime = %ld, end time = %ld, timecost = %ld \n***",i,starttime, endtime, endtime - starttime);
        usleep(1000*50);
        i++;
    }
    //假装发完了，按了按钮，这时候发一个静音包，这个包里面可以有语音数据，也可以没有
    context.voice_request_end = true;
    char bufEmpyt[3200] = {0};
    xiaowei_request(voice_id, xiaowei_chat_via_voice, bufEmpyt, 3200, &context);
    printf("voice request end\n");
    fclose(f);
}


////////////////////////
void TESTFUN::voipWechatStart()
{
    VOIP_CALLBACK callback = {0};
    callback.on_receiveMessage = TESTCALLBACK::onReceiveMessage;
    callback.on_send_msg_result = TESTCALLBACK::onSendMsgResult;
    callback.on_voip_invite = TESTCALLBACK::onVoipInvite;
    voip_service_start(&callback);
}
void TESTFUN::voipWechatStop()
{
    voip_service_stop();
}
